import * as i0 from '@angular/core';
import { forwardRef, Directive, ElementRef, HostListener, Self, Inject, Input, NgModule } from '@angular/core';
import { CheckboxControlValueAccessor, NG_VALUE_ACCESSOR, DefaultValueAccessor, SelectControlValueAccessor, SelectMultipleControlValueAccessor } from '@angular/forms';
import { noop, isNil } from '@s-libs/micro-dash';
import { provideValueAccessor } from '@s-libs/ng-core';
import { __classPrivateFieldSet, __classPrivateFieldGet } from 'tslib';

/** @hidden */
class CheckboxValueAccessorDirective extends CheckboxControlValueAccessor {
}
CheckboxValueAccessorDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: CheckboxValueAccessorDirective, deps: null, target: i0.ɵɵFactoryTarget.Directive });
CheckboxValueAccessorDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "14.0.0", type: CheckboxValueAccessorDirective, selector: "input[type=checkbox][nasModel]", host: { listeners: { "change": "onChange($event.target.checked)", "blur": "onTouched()" } }, providers: [
        {
            provide: NG_VALUE_ACCESSOR,
            useExisting: forwardRef(() => CheckboxValueAccessorDirective),
            multi: true,
        },
    ], usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: CheckboxValueAccessorDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: 'input[type=checkbox][nasModel]',
                    // eslint-disable-next-line @angular-eslint/no-host-metadata-property
                    host: {
                        '(change)': 'onChange($event.target.checked)',
                        '(blur)': 'onTouched()',
                    },
                    providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: forwardRef(() => CheckboxValueAccessorDirective),
                            multi: true,
                        },
                    ],
                }]
        }] });

/** @hidden */
class InputValueAccessorDirective extends DefaultValueAccessor {
}
InputValueAccessorDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: InputValueAccessorDirective, deps: null, target: i0.ɵɵFactoryTarget.Directive });
InputValueAccessorDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "14.0.0", type: InputValueAccessorDirective, selector: "input:not([type=checkbox]):not([type=number]):not([type=radio]):not([type=range])[nasModel],textarea[nasModel]", host: { listeners: { "input": "$any(this)._handleInput($event.target.value)", "blur": "onTouched()", "compositionstart": "$any(this)._compositionStart()", "compositionend": "$any(this)._compositionEnd($event.target.value)" } }, providers: [
        {
            provide: NG_VALUE_ACCESSOR,
            useExisting: forwardRef(() => InputValueAccessorDirective),
            multi: true,
        },
    ], usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: InputValueAccessorDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: 'input:not([type=checkbox]):not([type=number]):not([type=radio]):not([type=range])[nasModel],textarea[nasModel]',
                    // eslint-disable-next-line @angular-eslint/no-host-metadata-property
                    host: {
                        '(input)': '$any(this)._handleInput($event.target.value)',
                        '(blur)': 'onTouched()',
                        '(compositionstart)': '$any(this)._compositionStart()',
                        '(compositionend)': '$any(this)._compositionEnd($event.target.value)',
                    },
                    providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: forwardRef(() => InputValueAccessorDirective),
                            multi: true,
                        },
                    ],
                }]
        }] });

class AbstractValueAccessorDirective {
    constructor(injector) {
        this.onTouchedFn = noop;
        this.elementRef = injector.get(ElementRef);
    }
    registerOnChange(fn) {
        this.onChangeFn = fn;
    }
    registerOnTouched(fn) {
        this.onTouchedFn = fn;
    }
    get element() {
        return this.elementRef.nativeElement;
    }
}
AbstractValueAccessorDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: AbstractValueAccessorDirective, deps: [{ token: i0.Injector }], target: i0.ɵɵFactoryTarget.Directive });
AbstractValueAccessorDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "14.0.0", type: AbstractValueAccessorDirective, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: AbstractValueAccessorDirective, decorators: [{
            type: Directive
        }], ctorParameters: function () { return [{ type: i0.Injector }]; } });

class AbstractInputValueAccessorDirective extends AbstractValueAccessorDirective {
    onChange() {
        this.onChangeFn(this.element.value);
    }
    onBlur() {
        this.onTouchedFn();
    }
    writeValue(value) {
        this.element.value = value;
    }
    setDisabledState(isDisabled) {
        this.element.disabled = isDisabled;
    }
}
AbstractInputValueAccessorDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: AbstractInputValueAccessorDirective, deps: null, target: i0.ɵɵFactoryTarget.Directive });
AbstractInputValueAccessorDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "14.0.0", type: AbstractInputValueAccessorDirective, host: { listeners: { "change": "onChange()", "input": "onChange()", "blur": "onBlur()" } }, usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: AbstractInputValueAccessorDirective, decorators: [{
            type: Directive
        }], propDecorators: { onChange: [{
                type: HostListener,
                args: ['change']
            }, {
                type: HostListener,
                args: ['input']
            }], onBlur: [{
                type: HostListener,
                args: ['blur']
            }] } });

/** @hidden */
class NumberValueAccessorDirective extends AbstractInputValueAccessorDirective {
    registerOnChange(fn) {
        this.onChangeFn = (value) => {
            fn(value === '' ? null : parseFloat(value));
        };
    }
    writeValue(value) {
        // The value needs to be normalized for IE9, otherwise it is set to 'null' when null
        this.element.value = isNil(value) ? '' : value.toString();
    }
}
NumberValueAccessorDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: NumberValueAccessorDirective, deps: null, target: i0.ɵɵFactoryTarget.Directive });
NumberValueAccessorDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "14.0.0", type: NumberValueAccessorDirective, selector: "input[type=number][nasModel]", providers: [provideValueAccessor(NumberValueAccessorDirective)], usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: NumberValueAccessorDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: 'input[type=number][nasModel]',
                    providers: [provideValueAccessor(NumberValueAccessorDirective)],
                }]
        }] });

/** @hidden */
class RadioValueAccessorDirective extends AbstractInputValueAccessorDirective {
    writeValue(obj) {
        // delay because `button.value` may not be set yet as the component is being initialized
        Promise.resolve().then(() => {
            this.element.checked = this.element.value === obj;
        });
    }
}
RadioValueAccessorDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: RadioValueAccessorDirective, deps: null, target: i0.ɵɵFactoryTarget.Directive });
RadioValueAccessorDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "14.0.0", type: RadioValueAccessorDirective, selector: "input[type=radio][nasModel]", providers: [provideValueAccessor(RadioValueAccessorDirective)], usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: RadioValueAccessorDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: 'input[type=radio][nasModel]',
                    providers: [provideValueAccessor(RadioValueAccessorDirective)],
                }]
        }] });

/** @hidden */
class RangeValueAccessorDirective extends AbstractInputValueAccessorDirective {
    registerOnChange(fn) {
        this.onChangeFn = (value) => {
            fn(parseFloat(value));
        };
    }
}
RangeValueAccessorDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: RangeValueAccessorDirective, deps: null, target: i0.ɵɵFactoryTarget.Directive });
RangeValueAccessorDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "14.0.0", type: RangeValueAccessorDirective, selector: "input[type=range][nasModel]", providers: [provideValueAccessor(RangeValueAccessorDirective)], usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: RangeValueAccessorDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: 'input[type=range][nasModel]',
                    providers: [provideValueAccessor(RangeValueAccessorDirective)],
                }]
        }] });

/** @hidden */
class SelectValueAccessorDirective extends SelectControlValueAccessor {
}
SelectValueAccessorDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: SelectValueAccessorDirective, deps: null, target: i0.ɵɵFactoryTarget.Directive });
SelectValueAccessorDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "14.0.0", type: SelectValueAccessorDirective, selector: "select:not([multiple])[nasModel]", host: { listeners: { "change": "onChange($event.target.value)", "blur": "onTouched()" } }, providers: [
        {
            provide: NG_VALUE_ACCESSOR,
            useExisting: forwardRef(() => SelectValueAccessorDirective),
            multi: true,
        },
        {
            provide: SelectControlValueAccessor,
            useExisting: forwardRef(() => SelectValueAccessorDirective),
        },
    ], usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: SelectValueAccessorDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: 'select:not([multiple])[nasModel]',
                    // eslint-disable-next-line @angular-eslint/no-host-metadata-property
                    host: {
                        '(change)': 'onChange($event.target.value)',
                        '(blur)': 'onTouched()',
                    },
                    providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: forwardRef(() => SelectValueAccessorDirective),
                            multi: true,
                        },
                        {
                            provide: SelectControlValueAccessor,
                            useExisting: forwardRef(() => SelectValueAccessorDirective),
                        },
                    ],
                }]
        }] });

/** @hidden */
class SelectMultipleValueAccessorDirective extends SelectMultipleControlValueAccessor {
}
SelectMultipleValueAccessorDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: SelectMultipleValueAccessorDirective, deps: null, target: i0.ɵɵFactoryTarget.Directive });
SelectMultipleValueAccessorDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "14.0.0", type: SelectMultipleValueAccessorDirective, selector: "select[multiple][nasModel]", host: { listeners: { "change": "onChange($event.target)", "blur": "onTouched()" } }, providers: [
        {
            provide: NG_VALUE_ACCESSOR,
            useExisting: forwardRef(() => SelectMultipleValueAccessorDirective),
            multi: true,
        },
        {
            provide: SelectMultipleControlValueAccessor,
            useExisting: forwardRef(() => SelectMultipleValueAccessorDirective),
        },
    ], usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: SelectMultipleValueAccessorDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: 'select[multiple][nasModel]',
                    // eslint-disable-next-line @angular-eslint/no-host-metadata-property
                    host: { '(change)': 'onChange($event.target)', '(blur)': 'onTouched()' },
                    providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: forwardRef(() => SelectMultipleValueAccessorDirective),
                            multi: true,
                        },
                        {
                            provide: SelectMultipleControlValueAccessor,
                            useExisting: forwardRef(() => SelectMultipleValueAccessorDirective),
                        },
                    ],
                }]
        }] });

var _NasModelDirective_store, _NasModelDirective_subscription, _NasModelDirective_valueAccessor;
class NasModelDirective {
    constructor(valueAccessors) {
        _NasModelDirective_store.set(this, void 0);
        _NasModelDirective_subscription.set(this, void 0);
        _NasModelDirective_valueAccessor.set(this, void 0);
        __classPrivateFieldSet(this, _NasModelDirective_valueAccessor, valueAccessors[0], "f");
    }
    set nasModel(store) {
        var _a;
        (_a = __classPrivateFieldGet(this, _NasModelDirective_subscription, "f")) === null || _a === void 0 ? void 0 : _a.unsubscribe();
        __classPrivateFieldSet(this, _NasModelDirective_store, store, "f");
        __classPrivateFieldSet(this, _NasModelDirective_subscription, store === null || store === void 0 ? void 0 : store.$.subscribe((value) => {
            __classPrivateFieldGet(this, _NasModelDirective_valueAccessor, "f").writeValue(value);
        }), "f");
    }
    set disabled(isDisabled) {
        var _a, _b;
        (_b = (_a = __classPrivateFieldGet(this, _NasModelDirective_valueAccessor, "f")).setDisabledState) === null || _b === void 0 ? void 0 : _b.call(_a, isDisabled !== null && isDisabled !== void 0 ? isDisabled : false);
    }
    ngAfterViewInit() {
        __classPrivateFieldGet(this, _NasModelDirective_valueAccessor, "f").registerOnChange((value) => {
            var _a;
            (_a = __classPrivateFieldGet(this, _NasModelDirective_store, "f")) === null || _a === void 0 ? void 0 : _a.set(value);
        });
    }
    ngOnDestroy() {
        var _a;
        (_a = __classPrivateFieldGet(this, _NasModelDirective_subscription, "f")) === null || _a === void 0 ? void 0 : _a.unsubscribe();
    }
}
_NasModelDirective_store = new WeakMap(), _NasModelDirective_subscription = new WeakMap(), _NasModelDirective_valueAccessor = new WeakMap();
NasModelDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: NasModelDirective, deps: [{ token: NG_VALUE_ACCESSOR, self: true }], target: i0.ɵɵFactoryTarget.Directive });
NasModelDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "14.0.0", type: NasModelDirective, selector: "[nasModel]", inputs: { nasModel: "nasModel", disabled: "disabled" }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: NasModelDirective, decorators: [{
            type: Directive,
            args: [{ selector: '[nasModel]' }]
        }], ctorParameters: function () {
        return [{ type: undefined, decorators: [{
                        type: Self
                    }, {
                        type: Inject,
                        args: [NG_VALUE_ACCESSOR]
                    }] }];
    }, propDecorators: { nasModel: [{
                type: Input
            }], disabled: [{
                type: Input
            }] } });

const exportedDirectives = [
    CheckboxValueAccessorDirective,
    InputValueAccessorDirective,
    NasModelDirective,
    NumberValueAccessorDirective,
    RadioValueAccessorDirective,
    RangeValueAccessorDirective,
    SelectValueAccessorDirective,
    SelectMultipleValueAccessorDirective,
];
class NasModelModule {
}
NasModelModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: NasModelModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NasModelModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.0.0", ngImport: i0, type: NasModelModule, declarations: [CheckboxValueAccessorDirective,
        InputValueAccessorDirective,
        NasModelDirective,
        NumberValueAccessorDirective,
        RadioValueAccessorDirective,
        RangeValueAccessorDirective,
        SelectValueAccessorDirective,
        SelectMultipleValueAccessorDirective], exports: [CheckboxValueAccessorDirective,
        InputValueAccessorDirective,
        NasModelDirective,
        NumberValueAccessorDirective,
        RadioValueAccessorDirective,
        RangeValueAccessorDirective,
        SelectValueAccessorDirective,
        SelectMultipleValueAccessorDirective] });
NasModelModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: NasModelModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: NasModelModule, decorators: [{
            type: NgModule,
            args: [{ declarations: exportedDirectives, exports: exportedDirectives }]
        }] });

/*
 * Public API Surface of ng-app-state
 */

/**
 * Generated bundle index. Do not edit.
 */

export { CheckboxValueAccessorDirective, InputValueAccessorDirective, NasModelDirective, NasModelModule, NumberValueAccessorDirective, RadioValueAccessorDirective, RangeValueAccessorDirective, SelectMultipleValueAccessorDirective, SelectValueAccessorDirective };
//# sourceMappingURL=ng-app-state.mjs.map
